/*
Odigo Flooder Example
Copyright (C) 2003 Alexander Turkovsky aKa gandalf_g@mail.ru

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//---------------------------------------------------------------------------------------
#pragma once


//---------------------------------------------------------------------------------------
#include "./zlib/ZLib_Compressor.h"


//---------------------------------------------------------------------------------------
void UTIL_ConvertUTF8toANSI( char *utf8, char *outstr );
void UTIL_ConvertANSItoUTF8( char *string, char *utf8 );


//---------------------------------------------------------------------------------------
class COdigoMessage
{
   // TODO: fix memory leaks

   CMemFile    *cmf;
   USHORT      us_pos;
   char        *s_conv;
   int         s_conv_len;
public:
   COdigoMessage( void ){ s_conv_len = 0; s_conv = NULL; cmf = NULL; }
   ~COdigoMessage( void ){ if( s_conv != NULL ) delete []s_conv; Release(); }
   
   void        AllocConvertBuff( int len = 40000 )
   {
      if( s_conv == NULL ) s_conv = new char[ len ];
      s_conv_len = len;
   }

   void        ResetUSLen( void ){ us_pos = 0; }

   void        Init( bool addhdr )
   {
      ResetUSLen();
      if( cmf != NULL ) cmf->SetLength( 0 );// just reset
      else cmf = new CMemFile( 512 );
      if( addhdr ){ AddBuffWL( (BYTE*)"FBS", 3, false ); AddByte( 0x00 ); }
   }

   void        Release( void )
   {
      if( cmf != NULL ) delete cmf;
      cmf = NULL;
   }

   int         GetMsgLen( void ){ return (int)cmf->GetLength(); }
   
   void        GetMsgBuff( BYTE *buff, int *lplen = NULL )
   {
      int len = GetMsgLen();
      ULONGLONG savpos = cmf->Seek( 0, CFile::current );
      cmf->Seek( 0, CFile::begin );
      cmf->Read( buff, len );
      cmf->Seek( savpos, CFile::begin );
      if( lplen != NULL ) *lplen = len;
   }

   void        Dump2File( char *fname )
   {
      int len = GetMsgLen();
      BYTE *buff = new BYTE[ len ];
      GetMsgBuff( buff );
      DumpMemory( fname, buff, len );
      delete buff;
   }

   void        AddShortLenToPos( int pos, bool resetpos = false )
   { 
      if( pos > GetMsgLen() ) return;
      ULONGLONG savpos = cmf->Seek( 0, CFile::current );
      cmf->Seek( pos, CFile::begin );
      USHORT us = us_pos;
      __asm
      {
         mov ax, us
         mov cl, ah
         mov ch, al
         mov us, cx
      }
      cmf->Write( &us, 2 ); 
      cmf->Seek( savpos, CFile::begin );
      if( resetpos ) ResetUSLen();
   }

   void        AddByte( BYTE bt ){ cmf->Write( &bt, 1 ); us_pos++; }
   void        AddRepeatedBytes( BYTE bt, BYTE num ){ for( BYTE i = 0; i < num; i++ ) AddByte( bt ); }
   void        AddShort( USHORT us ){ cmf->Write( &us, 2 ); us_pos += 2; }
   void        AddRShort( USHORT us )
   { 
      __asm
      {
         mov ax, us
         mov cl, ah
         mov ch, al
         mov us, cx
      }
      cmf->Write( &us, 2 ); 
      us_pos += 2;
   }
   
   void        AddDword( DWORD dw ){ cmf->Write( &dw, 4 ); us_pos += 4; }

   void        AddBuff( BYTE *buff, int len, bool ansi2utf8 )
   { 
      if( ansi2utf8 )
      {
         AllocConvertBuff();
         UTIL_ConvertANSItoUTF8( (char*)buff, s_conv );
         cmf->Write( s_conv, lstrlen( s_conv ) ); 
         us_pos += lstrlen( s_conv );
      }else{
         cmf->Write( buff, len ); 
         us_pos += len; 
      }
   }

   void        AddBuffWL( BYTE *buff, UCHAR len, bool ansi2utf8 )
   { 
      if( ansi2utf8 )
      {
         AllocConvertBuff();
         UTIL_ConvertANSItoUTF8( (char*)buff, s_conv );
         len = lstrlen( s_conv );
         AddByte( len ); 
         AddBuff( (BYTE*)s_conv, len, false ); 
      }else{
         AddByte( len ); 
         AddBuff( buff, len, false ); 
      }
   }
   
   void        ToBegin( void ){ cmf->SeekToBegin(); }
   void        ToEnd( void ){ cmf->SeekToEnd(); }
   void        ToPos( int pos ){ cmf->Seek( pos, CFile::begin ); }
   void        Skip( int pos ){ cmf->Seek( pos, CFile::current ); }
   int         GetPos( void ){ return (int)cmf->Seek( 0, CFile::current ); }

   BYTE        GetByte( void ){ BYTE bt; cmf->Read( &bt, 1 ); return bt; }
   USHORT      GetShort( void ){ USHORT us; cmf->Read( &us, 2 ); return us; }
   USHORT      GetRShort( void )
   { 
      USHORT us; 
      cmf->Read( &us, 2 ); 
      __asm
      {
         mov ax, us
         mov cl, ah
         mov ch, al
         mov us, cx
      }
      return us; 
   }
   DWORD       GetDword( void ){ DWORD dw; cmf->Read( &dw, 4 ); return dw; }
   
   void        GetBuff( BYTE *buff, int len, bool utf2ansi )
   { 
      if( utf2ansi )
      {
         //ZeroMemory( s_conv, s_conv_len );
         AllocConvertBuff();
         cmf->Read( s_conv, len ); 
         UTIL_ConvertUTF8toANSI( s_conv, (char*)buff );
      }else{
         cmf->Read( buff, len ); 
      }
   }
   
   int         GetBuffWL( BYTE *buff, bool utf2ansi, BYTE maxlen = 255 )
   { 
      BYTE len = GetByte(); 
      BYTE dif = 0;
      if( len > maxlen ){ dif = len - maxlen; len = maxlen; }
      int r;
      if( utf2ansi )
      {
         AllocConvertBuff();
         ZeroMemory( s_conv, s_conv_len );
         cmf->Read( s_conv, len );
         UTIL_ConvertUTF8toANSI( s_conv, (char*)buff );
         return lstrlen( (char*)buff );
      }else{
         r = cmf->Read( buff, len ); 
         buff[ r ] = 0; 
      }
      Skip( dif );
      return r; 
   }

   int         GetBuffWL2( BYTE *buff, bool utf2ansi, USHORT maxlen = 40000 )
   { 
      USHORT len = GetRShort(); 
      USHORT dif = 0;
      if( len > maxlen ){ dif = len - maxlen; len = maxlen; }
      int r;
      if( utf2ansi )
      {
         AllocConvertBuff();
         ZeroMemory( s_conv, s_conv_len );
         cmf->Read( s_conv, len );
         UTIL_ConvertUTF8toANSI( s_conv, (char*)buff );
         return lstrlen( (char*)buff );
      }else{
         r = cmf->Read( buff, len ); 
         buff[ r ] = 0; 
      }
      Skip( dif );
      return r; 
   }
};


//-------------------------------------------------------------------------------------------
#define MAX_ODIGO_MSG_TIMEOUTBUFF      1000
#define MAX_ODIGO_MSGRESPONSE          100
#define MAX_ODIGO_ROOMS                100
#define MAX_ODIGO_DIALOGS              200
#define MAX_ODIGO_PINGTIMEOUTS         3
#define ODIGO_SENDBUFF_LEN             60000
#define ODIGO_MESSAGE_TIMEOUT          3500
#define PONGTIMERID                    22521
#define PONGRESPONSETIMERID            22522
#define MSGPRESPTIMERID                22523
#define PONGRESPONSE_TIMEOUT           8000
#define MSG_TIMEOUT_CHECK_TIMERID      22524
#define MSG_TIMEOUT_CHECK_TIME         500

#define ODIGO_USER_STATUS_OFFLINE      0
#define ODIGO_USER_STATUS_ONLINE       1
#define ODIGO_USER_STATUS_BUSY         2
#define ODIGO_USER_STATUS_BACKSOON     3
#define ODIGO_USER_STATUS_AWAY         4
#define ODIGO_USER_STATUS_ONMEET       5
#define ODIGO_USER_STATUS_UNKNOWN      99


//-------------------------------------------------------------------------------------------
struct COdigoMessageResponse
{
   bool     isprivate;
   USHORT   conf;
   USHORT   id;
   char     from_name[ 100 ];
   char     from_host[ 100 ];
};


//-------------------------------------------------------------------------------------------
struct COdigoMessageTimeCheck
{
   DWORD    id;// = 0, free
   DWORD    timeout_tick;
};


//-------------------------------------------------------------------------------------------
class COdigoConnection
{

protected:
   COdigoMessageResponse MsgResponseStack[ MAX_ODIGO_MSGRESPONSE ];
   int m_iMsgResponseCount;

   COdigoMessageTimeCheck MsgsTimeCheckStack[ MAX_ODIGO_MSG_TIMEOUTBUFF ];

   ZLib_Compressor zlb;

   char           szExeDir[ 300 ];

   BYTE           buff[ ODIGO_SENDBUFF_LEN ];
   BYTE           SendBuff[ ODIGO_SENDBUFF_LEN ];
   BYTE           TempBuff[ ODIGO_SENDBUFF_LEN ];
   BYTE           TempBuff1[ ODIGO_SENDBUFF_LEN ];

   BYTE           FENum[ 300 ];
   USHORT         sessid, recv_sessid;
   BYTE           IMNum[ 300 ];
   char           odigo_user_name[ 300 ];// = "ggtest";
   char           odigo_user_host[ 300 ];// = "odigo.com";
   char           odigo_user_pass[ 300 ];// = "pass";
   
   char           odigo_addr[ 300 ];// "216.33.42.78"
   int            odigo_port;// 2562

   bool           bIsUseProxy;
   char           proxy_addr[ 300 ];// "127.0.0.1"
   int            proxy_port;// 1081


   HWND           m_Wnd;
   SOCKET         sock;
   bool           InternalRead;
   bool           m_bWaitingReceiveEvent;
   int            m_iPingTimeoutCount;

   int            m_iRecvCount;
   int            m_iSendCount;

   bool           WaitUntilRecv( DWORD ms );
   void           EncodePassKey( char *pass, char *key, UCHAR result[ 16 ] );
   void           SendPong( void );
   void           ProcessRecvBuffer( BYTE *buff, int bufflen );
   void           SendAuthMessage( BYTE *FE, char *key, USHORT recv_sessid );
   void           UserInOutTheRoom( COdigoMessage *om );
   void           ChatMessage( COdigoMessage *om );
   //void           RoomUserList( COdigoMessage *om );
   void           FillFriends( COdigoMessage *om );
   void           UserStatus( COdigoMessage *om );
   //void           ParseSearchResult( COdigoMessage *om );
   //void           ParseUsersSearchResult( COdigoMessage *om );
   void           MakeStdHeader( COdigoMessage *om, DWORD msgid, bool compressed );
   //void           FriendRequest( COdigoMessage *om );
   void           MsgConfirm( COdigoMessage *om );

   void           SendConfirmation( USHORT conf, USHORT sid );

   int            SendData( BYTE *buff, int len );
   int            RecvData( BYTE *buff, int maxlen );

   void           PushMessageTimeout( int recv_sessid, int timeout = ODIGO_MESSAGE_TIMEOUT );
   void           FreeMessageTimeout( int recv_sessid );
   void           CheckMessagesTimeout( void );
public:

   int            m_iRecvTraff;
   int            m_iSendTraff;

   void PushMsgResponse( bool isprivate, USHORT conf, USHORT id, char *fromname, char *fromhost )
   {
      MsgResponseStack[ m_iMsgResponseCount ].isprivate = isprivate;
      MsgResponseStack[ m_iMsgResponseCount ].conf = conf;
      MsgResponseStack[ m_iMsgResponseCount ].id = id;
      lstrcpy( MsgResponseStack[ m_iMsgResponseCount ].from_name, fromname );
      lstrcpy( MsgResponseStack[ m_iMsgResponseCount ].from_host, fromhost );
      if( m_iMsgResponseCount++ > MAX_ODIGO_MSGRESPONSE ) FlushResponseStack();
   }

   void FlushResponseStack( void );

   void ResetAll( void )
   {
      ZeroMemory( MsgsTimeCheckStack, sizeof( COdigoMessageTimeCheck ) * MAX_ODIGO_MSG_TIMEOUTBUFF );
      ZeroMemory( MsgResponseStack, sizeof( COdigoMessageResponse ) * MAX_ODIGO_MSGRESPONSE );
      m_iMsgResponseCount = 0;
      ZeroMemory( SendBuff, ODIGO_SENDBUFF_LEN );
      ZeroMemory( FENum, sizeof( FENum ) );
      ZeroMemory( IMNum, sizeof( IMNum ) );
      ZeroMemory( odigo_user_name, sizeof( odigo_user_name ) );
      ZeroMemory( odigo_user_host, sizeof( odigo_user_host ) );
      ZeroMemory( odigo_user_pass, sizeof( odigo_user_pass ) );
      ZeroMemory( buff, ODIGO_SENDBUFF_LEN );
      m_iRecvCount = 0;
      m_iSendCount = 0;
      m_iRecvTraff = 0;
      m_iSendTraff = 0;
      sock = NULL;
      m_Wnd = NULL;
      m_iPingTimeoutCount = 0;
   }

   COdigoConnection( void )
   {
      ResetAll();
   }
   
   ~COdigoConnection( void )
   {
      ODC_Disconnect();
   }
   
   void ODC_SetConnectionOptions( char *ExeDir, char *name, char *host, char *pass, bool proxy, char *proxyaddr, int proxyport, char *odigoaddr, int odigoport )
   {
      lstrcpy( szExeDir, ExeDir );

      lstrcpy( odigo_user_name, name );
      lstrcpy( odigo_user_host, host );
      lstrcpy( odigo_user_pass, pass );

      lstrcpy( odigo_addr, odigoaddr );
      odigo_port = odigoport;
      bIsUseProxy = proxy;
      lstrcpy( proxy_addr, proxyaddr );
      proxy_port = proxyport;
   }
   
   int  ODC_SendPrivateMessage( char *msg_to_name, char *msg_to_host, char *html_text );
   bool ODC_WindowProc( UINT message, WPARAM wParam, LPARAM lParam );
   //int  ODC_SendMessageToRoom( char *roomname, char *html_text );
   //int  ODC_SendPrivateMessageToRoom( char *roomname, char *from, char *to_who, char *html_text );
   //void ODC_EnterRoom( char *roomname, char *roomnik );
   //void ODC_ExitRoom( char *roomname );
   bool ODC_Connect( HWND hwnd );
   void ODC_Disconnect( void );
   //void ODC_PerformRoomSearch( char *roomid, char *subj, char *own_name, char *own_host, int page );
   //void ODC_PerformUsersSearch( char *text_nik, char *text_name, char *text_sname, char *text_email, int page );
   
   //void ODC_FriendAdd( char *name, char *host, char *nik, char *groupname );
   //void ODC_FriendRequest( char *name, char *host, char *nik, char *groupname, char *reqtext );
   //void ODC_FriendDelete( char *name, char *host, char *nik, char *groupname );
   //void ODC_FriendRename( char *name, char *host, char *new_nik, char *groupname );
   //void ODC_FriendMoveToGroup( char *name, char *host, char *nik, char *old_groupname, char *new_groupname );
   
   //void ODC_GroupAdd( char *groupname );
   //void ODC_GroupDelete( char *groupname );
   //void ODC_GroupRename( char *old_groupname, char *new_groupname );

   void ODC_Test( void );
   
   // overrides
   virtual void ODC_OnSocketClose( void ){}
   virtual void ODC_OnReceived( BYTE *buff, int read ){}
   virtual void ODC_OnSent( BYTE *buff, int len ){}
   virtual void ODC_OnSelfPing( void ){}
   //virtual void ODC_OnUserExitRoom( char *roomname, char *roomnik ){}
   //virtual void ODC_OnUserEnterRoom( char *roomname, char *roomnik, char *user_realname, char *user_realhost ){}

   virtual void ODC_OnRoomMessage( char *html_text, char *roomname, char *roomnik, char *user_realname, char *user_realhost, bool silent ){}
   virtual void ODC_OnPrivateMessage( char *html_text, char *fromnik, char *fromname, char *fromhost ){}
   virtual void ODC_OnMessageConfirm( int id ){}
   virtual void ODC_OnMessageTimeout( int id ){}

   //virtual void ODC_OnBeginRoomUserList( char *roomname, char *welcomemsg ){}
   //virtual void ODC_OnRoomUserList( char *roomname, BYTE num, char *fromnik, char *user_realname, char *user_realhost ){}
   //virtual void ODC_OnEndRoomUserList( char *roomname ){}

   virtual void ODC_OnSuccessfulAuthorize( void ){}
   virtual void ODC_OnFailedAuthorize( void ){}
   virtual void ODC_OnFailFriendsFill( void ){}
   virtual void ODC_OnBeginFriendsFill( void ){}
   virtual void ODC_OnFriendsFillGroup( char *groupname ){}
   virtual void ODC_OnFriendsFillUser( char *listname, char *user_realname, char *user_realhost ){}
   virtual void ODC_OnEndFriendsFill( void ){}

   virtual void ODC_OnUserStatusChange( int status, char *user_realname, char *user_realhost ){}

   //virtual void ODC_OnBeginRoomSearchFill( USHORT num ){}
   //virtual void ODC_OnRoomSearchResult( char *roomname, char *subject, char *desc, char *own_name, char *own_host, USHORT usersinchat ){}

   //virtual void ODC_OnBeginUsersSearchFill( USHORT num ){}
   //virtual void ODC_OnUsersSearchResult( char *usr_name, char *usr_host, char *usr_nik, char *usr_firstname, char *usr_secondname, char *usr_email ){}

   //virtual void ODC_OnFriendRequest( char *usr_numb, char *usr_host, char *request_text ){}
};

