/*
Odigo Flooder Example
Copyright (C) 2003 Alexander Turkovsky aKa gandalf_g@mail.ru

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _ZLIB_COMPRESSOR_H__
#define _ZLIB_COMPRESSOR_H__

#include "zlib.h"

//---------------------------------------------------------------------------------------
#define  ZLIB_ERROR_OK                0
#define  ZLIB_ERROR_CREATEFILE        1
#define  ZLIB_ERROR_OPENFILE          2
#define  ZLIB_ERROR_MEMORYALLOCATE    3
#define  ZLIB_ERROR_WRITEFILE         4
#define  ZLIB_ERROR_DEFLATE           5
#define  ZLIB_ERROR_INFLATE           6

//---------------------------------------------------------------------------------------
class ZLib_Compressor
{
private:
   BYTE    gabBuffIn[ 8096 ];
   BYTE    gabBuffOut[ 8096 ];
   #define kcbBuffIn sizeof(gabBuffIn)
   #define kcbBuffOut sizeof(gabBuffOut)
public:
   ZLib_Compressor();
   int     Total_In, Total_Out;

   int     LastError;
   
   int     Inflate_MemoryToFile( BYTE *pb, int cb, char *pszFullFn );
   int     Inflate_MemoryToMemory( UCHAR *In, int inlen, UCHAR *Out, int outmaxlen );

   int     Deflate_FileToFile( char *pszSrcFn, char *pszDstFn );
   int     Deflate_MemoryToMemory( UCHAR *In, int inlen, UCHAR *Out, int outmaxlen, int CompressionLevel = Z_BEST_COMPRESSION );
};


#endif